
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Overlay_profilesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const overlay_profiles = await db.overlay_profiles.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        overlay_type: data.overlay_type
        ||
        null
            ,
            
        access_token: data.access_token
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        canvas_settings_json: data.canvas_settings_json
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await overlay_profiles.setCreator( data.creator || null, {
            transaction,
        });
        
        await overlay_profiles.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        
        await overlay_profiles.setOverlay_widgets(data.overlay_widgets || [], {
            transaction,
        });
        

        

        return overlay_profiles;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const overlay_profilesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                overlay_type: item.overlay_type
            ||
            null
            ,
            
                access_token: item.access_token
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                canvas_settings_json: item.canvas_settings_json
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const overlay_profiles = await db.overlay_profiles.bulkCreate(overlay_profilesData, { transaction });

        // For each item created, replace relation files
        

        return overlay_profiles;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const overlay_profiles = await db.overlay_profiles.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.overlay_type !== undefined) updatePayload.overlay_type = data.overlay_type;
        
        
        if (data.access_token !== undefined) updatePayload.access_token = data.access_token;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.canvas_settings_json !== undefined) updatePayload.canvas_settings_json = data.canvas_settings_json;
        
        
        updatePayload.updatedById = currentUser.id;

        await overlay_profiles.update(updatePayload, {transaction});

        
        
        if (data.creator !== undefined) {
            await overlay_profiles.setCreator(
              
              data.creator,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await overlay_profiles.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        
        if (data.overlay_widgets !== undefined) {
            await overlay_profiles.setOverlay_widgets(data.overlay_widgets, { transaction });
        }
        

        

        return overlay_profiles;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const overlay_profiles = await db.overlay_profiles.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of overlay_profiles) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of overlay_profiles) {
                await record.destroy({transaction});
            }
        });


        return overlay_profiles;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const overlay_profiles = await db.overlay_profiles.findByPk(id, options);

        await overlay_profiles.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await overlay_profiles.destroy({
            transaction
        });

        return overlay_profiles;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const overlay_profiles = await db.overlay_profiles.findOne(
            { where },
            { transaction },
        );

        if (!overlay_profiles) {
            return overlay_profiles;
        }

        const output = overlay_profiles.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        output.streams_overlay_profile = await overlay_profiles.getStreams_overlay_profile({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        output.overlay_widgets_overlay_profile = await overlay_profiles.getOverlay_widgets_overlay_profile({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.creator = await overlay_profiles.getCreator({
            transaction
        });
        
        
        output.overlay_widgets = await overlay_profiles.getOverlay_widgets({
            transaction
        });
        
        
        output.organizations = await overlay_profiles.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.creator_profiles,
        as: 'creator',
        
        where: filter.creator ? {
          [Op.or]: [
            { id: { [Op.in]: filter.creator.split('|').map(term => Utils.uuid(term)) } },
            {
              handle: {
                [Op.or]: filter.creator.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },


      {
        model: db.overlay_widgets,
        as: 'overlay_widgets',
        required: false,
      },


    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'overlay_profiles',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.access_token) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'overlay_profiles',
                        'access_token',
                        filter.access_token,
                    ),
                };
            }
            
            if (filter.canvas_settings_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'overlay_profiles',
                        'canvas_settings_json',
                        filter.canvas_settings_json,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.overlay_type) {
                where = {
                    ...where,
                overlay_type: filter.overlay_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      


      if (filter.overlay_widgets) {
        const searchTerms = filter.overlay_widgets.split('|');

        include = [
          {
            model: db.overlay_widgets,
            as: 'overlay_widgets_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  instance_name: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.overlay_profiles.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'overlay_profiles',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.overlay_profiles.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

